#ifndef __EVENT_TYPES_HPP__
#define __EVENT_TYPES_HPP__

#include <cstddef>
#include <cstdint>
#include <vector>
#include <functional>
#include "DvsenseBase/Utils/TypeUtils.hpp"
#ifdef _WIN32
#define DVSENSE_API __declspec(dllexport)
#else
#define DVSENSE_API
#endif // _WIN32
namespace dvsense
{
    class EventBase
    {
    };

    class DVSENSE_API Event2D : public EventBase
    {
    public:
        Event2D(
            uint16_t x,
            uint16_t y,
            uint8_t polarity,
            uint64_t timestamp) : x(x), y(y), timestamp(timestamp), polarity(polarity) {}
        Event2D() : x(0), y(0), timestamp(0), polarity(0) {}
        uint16_t x;
        uint16_t y;
        /// @brief 0: decrease, 1: increase
        uint8_t polarity;
        /// @brief timestamp in microseconds
        uint64_t timestamp;
    };

    using Event2DVector = std::vector<Event2D>;
    using EventIterator_t = const Event2D*;
    using EventsStreamHandleCallback = std::function<void(EventIterator_t begin, EventIterator_t end)>;
} // namespace dvsense

#endif // __EVENT_TYPES_HPP__
