#ifndef DVS_CAMERA_UTILS_HPP
#define DVS_CAMERA_UTILS_HPP

#include <string>

#ifdef _WIN32
#define DVSENSE_API __declspec(dllexport)
#else
#define DVSENSE_API
#endif // _WIN32

namespace dvsense
{
    // ------- Hide from doxygen -------
    /** \cond */

    enum INTERFACE_TYPE
    {
        USB
    };

    enum CAMERA_TYPE
    {
        EVK4, 
        DvsLume
    };

    /** \endcond */
    // ------- Hide from doxygen end -------

    using Serial = std::string;

    /**
     * \~english @brief A struct to describe the camera information
     * \~chinese @brief 用于描述相机信息的结构体 
     */
    // TODO: Make Description class abstract according to interfaces
    struct DVSENSE_API CameraDescription
    {
        Serial serial;
        std::string product;
        std::string manufacturer;
        uint16_t vid;
        uint16_t pid;
        enum INTERFACE_TYPE interfaceType;
    };

} // namespace dvsense

#endif // DVS_CAMERA_UTILS_HPP
